#!/usr/bin/env python
# -*- coding:Utf-8 -*-

############################################
# Creation image et fichier contenant chansons, auteur et titre CD MP3  


# Copyright 2010 Gerard LE REST <gerard@infonie.fr>    
        
# This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
                                                     
############################################


#######################################################################
# Importation de fonctions externes:

from Tkinter import *
from ID3 import * 
from os import chdir, listdir, environ, mkdir, getcwd, error, remove
import tkFileDialog, Image, ImageDraw, ImageFont, ImageTk, shutil, tkMessageBox, glob, Pmw
from os.path import exists, isdir

class Back_cover:
    """creation de la page arrière de la jaquette d'un CD"""
    def __init__(self,repertoire_init="/media/cdrom0"):
        self.repertoire_init=repertoire_init
        self.lecteur=""   		# dossier du lecteur CD
        self.repertoire_fichier=sys.path[0]	# répertoire du programme
        self.repertoire_travail=""   # repertoire de travail
        
    def fichier(self):
        " creation du fichier tags.txt conrenant toutes les lignes à editer"
        self.lecteur=tkFileDialog.askdirectory(initialdir=self.repertoire_init, title="choisir le répertoire du lecteur CD")
        chdir (self.lecteur)
        elements=listdir(self.lecteur)
        dossiers=[]
        # recuperation des sous-dossiers
        for i in elements:
            if isdir(i)==True:
                dossiers.append(i)
        # création de ~/PyCDCover/:
        chdir ("/"+environ['HOME'])
        if exists("PyCDCover")==FALSE:
            mkdir ("PyCDCover")
        self.repertoire_travail="/"+environ['HOME']+"/PyCDCover"
        chdir(self.repertoire_travail)
        # création du fichier tags.txt
        self.fichier=open("tags.txt",'w')
        chdir (self.lecteur)
        for i in dossiers:
            fichiers_sous_dossiers=listdir(i)
            chdir(i)
            # détection de sous-dossiers
            sous_dossiers=[]
            for j in fichiers_sous_dossiers:
                if isdir(j):
                    sous_dossiers.append(j)
            # s'il existe des sous-dossiers dans le dossier:
            if sous_dossiers!=[]:
                for j in sous_dossiers:
                    chdir (j)
                    self.ecriture_album_fichier()
                    chdir(self.lecteur+"/"+i)
            # s'il existe des *.mp3 dans le dossier et non des sous-dossiers
            if sous_dossiers==[]:
                self.ecriture_album_fichier()
            chdir(self.lecteur)
        self.fichier.close()
        chdir(self.repertoire_travail)
        self.fichier=open("tags.txt",'r')
        lignes=self.fichier.readlines()
    
    def ecriture_album_fichier(self):
            "ecriture des lignes de l'album dans le fichier"
            # récupération des fichiers mp3
            chansons=glob.glob("*.mp3")
            print chansons
            try:
                id3info = ID3(chansons[0])
                print id3info["ARTIST"],":",id3info["ALBUM"]
                self.fichier.write("C: "+id3info["ARTIST"]+"\n")
                self.fichier.write("A: "+ "* " + id3info["ALBUM"]+ " *"+"\n")
            except:
                self.fichier.write("ERROR"+"\n")
            N=0 # N° de chanson
            for j in chansons:
                N=N+1
                try:
                    id3info = ID3(j)
                    print id3info["TITLE"]
                    self.fichier.write(str(N) + " - " + id3info["TITLE"]+"\n")
                except:
                    self.fichier.write(str(N) + " - " + "ERROR"+"\n")
            chdir(self.lecteur)
            self.fichier.write("\n") # espace entre les albums
            
    def image(self):
        "création de l'image à partir du fichier texte"
        self.repertoire_travail="/"+environ['HOME']+"/PyCDCover"
        police1=self.repertoire_fichier+"/LiberationMono-Regular.ttf"
        police2=self.repertoire_fichier+"/LiberationMono-Bold.ttf"
        police3=self.repertoire_fichier+"/LiberationMono-BoldItalic.ttf"
        chdir(self.repertoire_travail)
        im = Image.new("RGB", (1380,930), "white")
        im.save("Image_Back_Cover.png", "png")
        draw = ImageDraw.Draw(im)
        fichier=open("tags.txt",'r')
        lignes=fichier.readlines()
        nbreLignes=len(lignes)
        nbreColonnes=3
        taille=890/((nbreLignes+1)/nbreColonnes)  # 3: nbre de rangées
        if taille>26:
            taille=26
        font3 = ImageFont.truetype(police3, taille)
        font2 = ImageFont.truetype(police2, taille)
        font1 = ImageFont.truetype(police1, taille)
        x,y=20,20 
        index=0
        while index<nbreLignes:
        # auteur + titre album:
            if (lignes[index][0]=="C") and (draw.textsize(lignes[index][3:],font=font2)[0]>(1340/nbreColonnes-5)):
                while draw.textsize(lignes[index][3:],font=font2)[0]>(1340/nbreColonnes):
                    lignes[index]=lignes[index][:-1]
            if (lignes[index][0]=="A") and (draw.textsize(lignes[index],font=font3)[0]>(1340/nbreColonnes-5)):
                while draw.textsize(lignes[index][3:],font=font3)[0]>(1320/nbreColonnes):
                    lignes[index]=lignes[index][:-1]
            if (lignes[index][0]!="C") and (lignes[index][0]!="A") and (draw.textsize(lignes[index],font=font3)[0]>(1340/nbreColonnes-5)):
                while draw.textsize(lignes[index],font=font1)[0]>(1340/nbreColonnes-10):
                    lignes[index]=lignes[index][:-1]
            index=index+1
        for i in lignes:
            if i[0]=="C":    # auteur + titre album
                font2 = ImageFont.truetype(police2, taille)
                draw.text((x,y),i[3:(len(i)-1)],anchor=NW, fill="black", font=font2)  
            elif i[0]=="A":    # auteur + titre album
                font2 = ImageFont.truetype(police3, taille)
                draw.text((x,y),i[3:(len(i)-1)],anchor=NW, fill="black", font=font3)  
            else:       # chansons
                font1 = ImageFont.truetype(police1, taille)
                draw.text((x,y),i[:(len(i)-1)],anchor=NW, fill="black", font=font1)
            y=y+taille
            if y>910-taille:
                y=20
                x=x+1340/nbreColonnes
        im.save("Image_Back_Cover.png", "png")
    
    def affichage(self,fenetre,image):
        "visualisation de l'aperçu"
        Pmw.initialise()
        SC=Pmw.ScrolledCanvas(fenetre,usehullsize =1, hull_width =900, hull_height =600,  
                       canvas_bg ='grey40', canvasmargin =10,borderframe =1, borderframe_borderwidth =3)
        # configuration des barres de défilement        
        SC.configure(vscrollmode ='static', hscrollmode ='static')        
        SC.pack(padx =5, pady =5, expand =YES, fill =BOTH)
        SC.can = SC.interior()        # accès au composant canevas
        # Ajout de l'image Dos.png :    
        im=Image.open(image)
        photo= ImageTk.PhotoImage(im)    
        SC.can.create_image(0,0,image=photo)
        self.photo=photo   # mémorisation pour eviter effacement image (bug ImageTk) 
        SC.resizescrollregion()


###################################
if __name__ == "__main__":
    "creation des groupes"
    # creation de la fenetre et cration de l'objet "conteneur"
    fenetre=Tk()
    app = Back_cover()
    app.fichier()
    app.image()
    app.affichage(fenetre,"Image_Back_Cover.png")
    fenetre.mainloop()
