#!/usr/bin/env python
# -*- coding:Utf-8 -*-


#######################################
# Création image CD MP3 - TP          #

# Copyright 2010 Gérard LE REST <gerard@infonie.fr> 
           
# This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.  
                       #
#######################################


#######################################################################
# Importation de fonctions externes:

from Tkinter import *
from math import sqrt, ceil
import os, sys, ImageDraw, tkFileDialog, shutil,tkMessageBox,Pmw, ImageTk
from PIL import Image

#########################################################################      
formats_3=('bmp','gif','jpg','msp','pcx','png','ppm','xbm',
                   'BMP','GIF','JPG','MSP','PCX','PNG','PPM','PNG','xbm')
formats_4=('jpeg','tiff','JPEG','TIFF')

class Thumbnails:
    """ cree une image composees de miniatures"""

    def __init__(self,largeur=300, hauteur=300):
        self.largeur=largeur    # largeur des images
        self.hauteur=hauteur    # hauteur des images
        self.dossier=""         # dossier originale des photos
        self.dossier_thumb=""   # dossier finale des photos
    
    def creation_images(self):
        "recherche les images dans le dossier et les convertit en jpeg"
        self.dossier=tkFileDialog.askdirectory(initialdir="/home/gerard/Desktop", title=" choisir le répertoire des images")
        os.chdir(self.dossier)
        fichiers=os.listdir(self.dossier)    # récuperation de la liste des noms de fichiers
        # création du dossier de destination si nécessaire
        # gestion du dossier personnel sous windows!
        if 'HOME' in os.environ:
            self.envHome = os.environ['HOME']
        elif 'HOMEDRIVE' in os.environ and 'HOMEPATH' in os.environ:
            self.envHome = os.path.join(os.environ['HOMEDRIVE'],os.environ['HOMEPATH'])
        os.chdir (self.envHome)
        if os.path.exists("PyCDCover")==FALSE:
            os.mkdir ("PyCDCover")
        os.chdir (self.envHome+os.sep+"PyCDCover")
        # effacement du dossier thumbnaols précédent
        if os.path.exists("thumbnails")==TRUE:
            shutil.rmtree("thumbnails")
        os.mkdir("thumbnails")
        self.dossier_thumb=(self.envHome+os.sep+"PyCDCover"+os.sep+"thumbnails")
        os.chdir(self.dossier)
        # extraction des images parmi les fichiers et convertion en JPEG
        N=1     # N° de photo
        for i in fichiers:
            # images .XXX
            for j in formats_3:
                if i[(len(i)-3):]==j:
                    im=Image.open(i)
                    out=im.resize((self.largeur,self.hauteur))
                    os.chdir(self.dossier_thumb)
                    out.save("im"+str(N)+".jpeg","jpeg")
                    os.chdir(self.dossier)
                    N=N+1
            # images *.XXXX        
            for j in formats_4:
                if i[(len(i)-4):]==j:
                    im=Image.open(i)
                    out=im.resize((self.largeur,self.hauteur))
                    os.chdir(self.dossier_thumb)
                    out.save("im"+str(N)+".jpeg","jpeg")
                    os.chdir(self.dossier)
                    N=N+1
        
    def assemblage(self):
        os.chdir(self.dossier_thumb)
        fichiers=os.listdir(self.dossier_thumb)    # récuperation de la liste des noms de fichiers
        try:
            NiL=ceil(sqrt(len(fichiers)))   # NiL: nbre d'images en largeur
            Nih=ceil(len(fichiers)/NiL)      # NiH: nbre d'images en hauteur
            NiL=int(NiL)
            Nih=int(Nih)
            Nid=len(fichiers)%NiL   # nombres d'images sur la dernière ligne si <NiL
            Larg_Im_fin=NiL*self.largeur+(NiL+1)*10 # largeur de l'image finale
            Haut_Im_fin=Nih*self.hauteur+(Nih+1)*10 # hauteur de l'image finale
            # création du fond de l'image finale
            im = Image.new("RGB", (Larg_Im_fin,Haut_Im_fin), "white")
            draw = ImageDraw.Draw(im)
            # insertion des thumbnails
            index=0
            for j in range(Nih):
                for i in range(NiL):
                    if (len(fichiers)>index) and ((j<Nih-1) or (Nid==0)):
                        into=Image.open(fichiers[index])  # image à insérer
                        im.paste(into,(10+(10+self.largeur)*i,10+(10+self.hauteur)*j,10+
                                (10+self.largeur)*i+self.largeur,10+(10+self.hauteur)*j+self.hauteur))
                    elif (len(fichiers)>index) and (j==(Nih-1)) and (Nid!=0):
                        marge=(Larg_Im_fin-(Nid-1)*10-Nid*self.largeur)/2
                        marge=int(marge)
                        into=Image.open(fichiers[index])  # image à insérer
                        im.paste(into,(marge+(10+self.largeur)*i,10+(10+self.hauteur)*j,marge+(10+
                                       self.largeur)*i+self.largeur,10+(10+self.hauteur)*j+self.hauteur))
                    index=index+1
            os.chdir(self.envHome+os.sep+"PyCDCover")        
            im.save("Image_thumbnails.jpeg", "jpeg")
            # effacement du dossier thumbnail
            shutil.rmtree("thumbnails")        
        except ZeroDivisionError:
            tkMessageBox.showinfo("Info","Aucune image trouvée")
            
    def affichage(self,fenetre,image):
            "visualisation de l'aperçu"
            Pmw.initialise()
            H,L=fenetre.winfo_screenheight(), fenetre.winfo_screenwidth() # résolution de l'écran
            SC=Pmw.ScrolledCanvas(fenetre,usehullsize =1, hull_width =(L-60), hull_height =(H-60),  
                           canvas_bg ='grey40', canvasmargin =10,borderframe =1, borderframe_borderwidth =3)
            # configuration des barres de défilement        
            SC.configure(vscrollmode ='static', hscrollmode ='static')        
            SC.pack(padx =5, pady =5, expand =YES, fill =BOTH)
            SC.can = SC.interior()        # accès au composant canevas
            # Ajout de l'image Dos.png :    
            im=Image.open(image)
            photo= ImageTk.PhotoImage(im)    
            SC.can.create_image(0,0,image=photo)
            self.photo=photo   # mémorisation pour éviter l'effacement image (bug ImageTk) 
            SC.resizescrollregion()

    #########################################################################     
if __name__ == "__main__":
    fen=Tk()
    App=Thumbnails(300,300)
    App.creation_images()
    App.assemblage()
    # gestion du dossier personnel sous windows!
    if 'HOME' in os.environ:
        envHome = os.environ['HOME']
    elif 'HOMEDRIVE' in os.environ and 'HOMEPATH' in os.environ:
        envHome = os.path.join(os.environ['HOMEDRIVE'],os.environ['HOMEPATH'])
    App.affichage(fen,envHome+os.sep+"PyCDCover"+os.sep+"Image_thumbnails.jpeg")
    fen.mainloop()
